org.apache.sysds.runtime.instructions.cp

## Class ComputationCPInstruction

- java.lang.Object
- - org.apache.sysds.runtime.instructions.Instruction
  - - org.apache.sysds.runtime.instructions.cp.CPInstruction
    - - org.apache.sysds.runtime.instructions.cp.ComputationCPInstruction

- All Implemented Interfaces:
    LineageTraceable
  Direct Known Subclasses:
    AggregateTernaryCPInstruction, BinaryCPInstruction, CompressionCPInstruction, CtableCPInstruction, DeCompressionCPInstruction, MultiReturnBuiltinCPInstruction, MultiReturnParameterizedBuiltinCPInstruction, ParameterizedBuiltinCPInstruction, PMMJCPInstruction, QuaternaryCPInstruction, SpoofCPInstruction, TernaryCPInstruction, UnaryCPInstruction

      public abstract class ComputationCPInstruction
      extends CPInstruction
      implements LineageTraceable

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.sysds.runtime.instructions.cp.CPInstruction

      `CPInstruction.CPType`

    - ### Nested classes/interfaces inherited from class org.apache.sysds.runtime.instructions.Instruction

      `Instruction.IType`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `CPOperand` | `input1`
    `CPOperand` | `input2`
    `CPOperand` | `input3`
    `CPOperand` | `output`

    - ### Fields inherited from class org.apache.sysds.runtime.instructions.Instruction

      `DATATYPE_PREFIX, FEDERATED_INST_PREFIX, GPU_INST_PREFIX, INSTRUCTION_DELIM, LITERAL_PREFIX, OPERAND_DELIM, SP_INST_PREFIX, VALUETYPE_PREFIX`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `CPOperand[]` | `getInputs()`
    `org.apache.commons.lang3.tuple.Pair<String,LineageItem>` | `getLineageItem(ExecutionContext ec)` Obtain lineage trace of an instruction with a single output.
    `CPOperand` | `getOutput()`
    `String` | `getOutputVariableName()`

    - ### Methods inherited from class org.apache.sysds.runtime.instructions.cp.CPInstruction

      `getCPInstructionType, getGraphString, getType, postprocessInstruction, preprocessInstruction, processInstruction, requiresLabelUpdate, updateLabels`

    - ### Methods inherited from class org.apache.sysds.runtime.instructions.Instruction

      `getBeginColumn, getBeginLine, getEndColumn, getEndLine, getExtendedOpcode, getFilename, getInstID, getInstructionString, getLineNum, getOpcode, getOperator, getPrivacyConstraint, printMe, setInstID, setLocation, setLocation, setLocation, setLocation, setPrivacyConstraint, setPrivacyConstraint, toString, updateInstructionThreadID`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.sysds.runtime.lineage.LineageTraceable

      `getLineageItems, hasSingleLineage`

- - ### Field Detail

    - #### output

          public final CPOperand output

    - #### input1

          public final CPOperand input1

    - #### input2

          public final CPOperand input2

    - #### input3

          public final CPOperand input3

  - ### Method Detail

    - #### getOutputVariableName

          public String getOutputVariableName()

    - #### getOutput

          public CPOperand getOutput()

    - #### getInputs

          public CPOperand[] getInputs()

    - #### getLineageItem

          public org.apache.commons.lang3.tuple.Pair<String,LineageItem> getLineageItem(ExecutionContext ec)

      Description copied from interface: `LineageTraceable`
      Obtain lineage trace of an instruction with a single output.
      Specified by:
        `getLineageItem` in interface `LineageTraceable`
      Parameters:
        `ec` - execution context w/ live variables
      Returns:
        pair of (output variable name, output lineage item)

Copyright © 2021 The Apache Software Foundation. All rights reserved.